// Code generated by protoc-gen-go. DO NOT EDIT.
// source: github.com/lightstep/lightstep-tracer-common/tmpgen/metrics.proto

/*
Package metricspb is a generated protocol buffer package.

It is generated from these files:
	github.com/lightstep/lightstep-tracer-common/tmpgen/metrics.proto

It has these top-level messages:
	MetricPoint
	IngestRequest
	IngestResponse
*/
package metricspb // import "github.com/lightstep/lightstep-tracer-common/golang/protobuf/metricspb"

import proto "github.com/golang/protobuf/proto"
import fmt "fmt"
import math "math"
import lightstep_collector "github.com/lightstep/lightstep-tracer-common/golang/protobuf/collectorpb"
import google_protobuf2 "github.com/golang/protobuf/ptypes/duration"
import google_protobuf "github.com/golang/protobuf/ptypes/timestamp"

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion2 // please upgrade the proto package

// MetricKind indicates the semantics of the points (i.e. how to interpret values
// relative to each other).
type MetricKind int32

const (
	// InvalidMetricKind is the default value for the MetricKind. Some languages' proto compilers
	// (e.g. Go) return the default if no value is set. The default is marked invalid here to
	// avoid a common mistake where a field is left unset and appears to be set to the default.
	MetricKind_INVALID_METRIC_KIND MetricKind = 0
	// Counter metrics measure change over an interval.
	// When aggregated, counter metrics are usually added.
	MetricKind_COUNTER MetricKind = 1
	// Gauge metrics measure the value at a point in time.
	// When aggregated, intermediate values are often dropped for the latest value.
	MetricKind_GAUGE MetricKind = 2
)

var MetricKind_name = map[int32]string{
	0: "INVALID_METRIC_KIND",
	1: "COUNTER",
	2: "GAUGE",
}
var MetricKind_value = map[string]int32{
	"INVALID_METRIC_KIND": 0,
	"COUNTER":             1,
	"GAUGE":               2,
}

func (x MetricKind) String() string {
	return proto.EnumName(MetricKind_name, int32(x))
}
func (MetricKind) EnumDescriptor() ([]byte, []int) { return fileDescriptor0, []int{0} }

// MetricPoint is an update to a single measure.
type MetricPoint struct {
	// Kind indicates the semantics of this point. Kind should always be the same for a given metric
	// name (e.g. "cpu.usage" should always have the same kind)
	Kind MetricKind `protobuf:"varint,1,opt,name=kind,enum=lightstep.metrics.MetricKind" json:"kind,omitempty"`
	// MetricName indicates the metric being emitted.
	MetricName string `protobuf:"bytes,2,opt,name=metric_name,json=metricName" json:"metric_name,omitempty"`
	// Start of the interval for which the points represent.
	// - All Counter points will be assumed to represent the entire interval.
	// - All Gauge points will be assumed to be instantaneous at the start of the interval.
	Start *google_protobuf.Timestamp `protobuf:"bytes,3,opt,name=start" json:"start,omitempty"`
	// Duration of the interval for which the points represent. The end of the interval is start + duration.
	// We expect this value to be unset or zero for Gauge points.
	Duration *google_protobuf2.Duration `protobuf:"bytes,4,opt,name=duration" json:"duration,omitempty"`
	// Labels contain labels specific to this point.
	Labels []*lightstep_collector.KeyValue `protobuf:"bytes,5,rep,name=labels" json:"labels,omitempty"`
	// Value represents the update being emitted. Values can be one of two types: uint64 or double.
	// The type of the value should always be the same for a given metric name (e.g. "cpu.usage"
	// should always have value type double).
	//
	// Types that are valid to be assigned to Value:
	//	*MetricPoint_Uint64Value
	//	*MetricPoint_DoubleValue
	Value isMetricPoint_Value `protobuf_oneof:"value"`
}

func (m *MetricPoint) Reset()                    { *m = MetricPoint{} }
func (m *MetricPoint) String() string            { return proto.CompactTextString(m) }
func (*MetricPoint) ProtoMessage()               {}
func (*MetricPoint) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{0} }

type isMetricPoint_Value interface {
	isMetricPoint_Value()
}

type MetricPoint_Uint64Value struct {
	Uint64Value uint64 `protobuf:"varint,6,opt,name=uint64_value,json=uint64Value,oneof"`
}
type MetricPoint_DoubleValue struct {
	DoubleValue float64 `protobuf:"fixed64,7,opt,name=double_value,json=doubleValue,oneof"`
}

func (*MetricPoint_Uint64Value) isMetricPoint_Value() {}
func (*MetricPoint_DoubleValue) isMetricPoint_Value() {}

func (m *MetricPoint) GetValue() isMetricPoint_Value {
	if m != nil {
		return m.Value
	}
	return nil
}

func (m *MetricPoint) GetKind() MetricKind {
	if m != nil {
		return m.Kind
	}
	return MetricKind_INVALID_METRIC_KIND
}

func (m *MetricPoint) GetMetricName() string {
	if m != nil {
		return m.MetricName
	}
	return ""
}

func (m *MetricPoint) GetStart() *google_protobuf.Timestamp {
	if m != nil {
		return m.Start
	}
	return nil
}

func (m *MetricPoint) GetDuration() *google_protobuf2.Duration {
	if m != nil {
		return m.Duration
	}
	return nil
}

func (m *MetricPoint) GetLabels() []*lightstep_collector.KeyValue {
	if m != nil {
		return m.Labels
	}
	return nil
}

func (m *MetricPoint) GetUint64Value() uint64 {
	if x, ok := m.GetValue().(*MetricPoint_Uint64Value); ok {
		return x.Uint64Value
	}
	return 0
}

func (m *MetricPoint) GetDoubleValue() float64 {
	if x, ok := m.GetValue().(*MetricPoint_DoubleValue); ok {
		return x.DoubleValue
	}
	return 0
}

// XXX_OneofFuncs is for the internal use of the proto package.
func (*MetricPoint) XXX_OneofFuncs() (func(msg proto.Message, b *proto.Buffer) error, func(msg proto.Message, tag, wire int, b *proto.Buffer) (bool, error), func(msg proto.Message) (n int), []interface{}) {
	return _MetricPoint_OneofMarshaler, _MetricPoint_OneofUnmarshaler, _MetricPoint_OneofSizer, []interface{}{
		(*MetricPoint_Uint64Value)(nil),
		(*MetricPoint_DoubleValue)(nil),
	}
}

func _MetricPoint_OneofMarshaler(msg proto.Message, b *proto.Buffer) error {
	m := msg.(*MetricPoint)
	// value
	switch x := m.Value.(type) {
	case *MetricPoint_Uint64Value:
		b.EncodeVarint(6<<3 | proto.WireVarint)
		b.EncodeVarint(uint64(x.Uint64Value))
	case *MetricPoint_DoubleValue:
		b.EncodeVarint(7<<3 | proto.WireFixed64)
		b.EncodeFixed64(math.Float64bits(x.DoubleValue))
	case nil:
	default:
		return fmt.Errorf("MetricPoint.Value has unexpected type %T", x)
	}
	return nil
}

func _MetricPoint_OneofUnmarshaler(msg proto.Message, tag, wire int, b *proto.Buffer) (bool, error) {
	m := msg.(*MetricPoint)
	switch tag {
	case 6: // value.uint64_value
		if wire != proto.WireVarint {
			return true, proto.ErrInternalBadWireType
		}
		x, err := b.DecodeVarint()
		m.Value = &MetricPoint_Uint64Value{x}
		return true, err
	case 7: // value.double_value
		if wire != proto.WireFixed64 {
			return true, proto.ErrInternalBadWireType
		}
		x, err := b.DecodeFixed64()
		m.Value = &MetricPoint_DoubleValue{math.Float64frombits(x)}
		return true, err
	default:
		return false, nil
	}
}

func _MetricPoint_OneofSizer(msg proto.Message) (n int) {
	m := msg.(*MetricPoint)
	// value
	switch x := m.Value.(type) {
	case *MetricPoint_Uint64Value:
		n += proto.SizeVarint(6<<3 | proto.WireVarint)
		n += proto.SizeVarint(uint64(x.Uint64Value))
	case *MetricPoint_DoubleValue:
		n += proto.SizeVarint(7<<3 | proto.WireFixed64)
		n += 8
	case nil:
	default:
		panic(fmt.Sprintf("proto: unexpected type %T in oneof", x))
	}
	return n
}

// IngestRequest is an update to one or more measures.
type IngestRequest struct {
	// IdempotencyKey is a random string that should uniquely identify this report.
	// It should be generated once and used for all retries. The server will use it
	// to de-duplicate requests.
	IdempotencyKey string `protobuf:"bytes,1,opt,name=idempotency_key,json=idempotencyKey" json:"idempotency_key,omitempty"`
	// Reporter contains information to identify the specific originator of this report.
	Reporter *lightstep_collector.Reporter `protobuf:"bytes,2,opt,name=reporter" json:"reporter,omitempty"`
	// Points contain the individual updates.
	Points []*MetricPoint `protobuf:"bytes,3,rep,name=points" json:"points,omitempty"`
}

func (m *IngestRequest) Reset()                    { *m = IngestRequest{} }
func (m *IngestRequest) String() string            { return proto.CompactTextString(m) }
func (*IngestRequest) ProtoMessage()               {}
func (*IngestRequest) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{1} }

func (m *IngestRequest) GetIdempotencyKey() string {
	if m != nil {
		return m.IdempotencyKey
	}
	return ""
}

func (m *IngestRequest) GetReporter() *lightstep_collector.Reporter {
	if m != nil {
		return m.Reporter
	}
	return nil
}

func (m *IngestRequest) GetPoints() []*MetricPoint {
	if m != nil {
		return m.Points
	}
	return nil
}

// IngestResponse is reserved for future use.
type IngestResponse struct {
}

func (m *IngestResponse) Reset()                    { *m = IngestResponse{} }
func (m *IngestResponse) String() string            { return proto.CompactTextString(m) }
func (*IngestResponse) ProtoMessage()               {}
func (*IngestResponse) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{2} }

func init() {
	proto.RegisterType((*MetricPoint)(nil), "lightstep.metrics.MetricPoint")
	proto.RegisterType((*IngestRequest)(nil), "lightstep.metrics.IngestRequest")
	proto.RegisterType((*IngestResponse)(nil), "lightstep.metrics.IngestResponse")
	proto.RegisterEnum("lightstep.metrics.MetricKind", MetricKind_name, MetricKind_value)
}

func init() {
	proto.RegisterFile("github.com/lightstep/lightstep-tracer-common/tmpgen/metrics.proto", fileDescriptor0)
}

var fileDescriptor0 = []byte{
	// 513 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x94, 0x92, 0xcd, 0x6e, 0xd3, 0x40,
	0x14, 0x85, 0xeb, 0xfc, 0x36, 0x63, 0x08, 0x61, 0x58, 0xe0, 0x46, 0xa2, 0xb5, 0xc2, 0x02, 0x0b,
	0xa9, 0x36, 0x14, 0x5a, 0x89, 0x05, 0x8b, 0xa4, 0x89, 0x4a, 0x94, 0x36, 0x44, 0x43, 0x5a, 0x21,
	0x36, 0x91, 0xed, 0x5c, 0x5c, 0xab, 0x9e, 0x1f, 0xc6, 0x63, 0xa4, 0xbc, 0x0e, 0x5b, 0x5e, 0x87,
	0x07, 0x42, 0x19, 0x3b, 0x71, 0xa1, 0xea, 0xa2, 0x3b, 0xeb, 0x9c, 0x6f, 0x66, 0xce, 0xbd, 0xc7,
	0xa8, 0x1f, 0xc5, 0xea, 0x3a, 0x0b, 0xdc, 0x90, 0x53, 0x2f, 0x89, 0xa3, 0x6b, 0x95, 0x2a, 0x10,
	0xe5, 0xd7, 0xa1, 0x92, 0x7e, 0x08, 0xf2, 0x30, 0xe4, 0x94, 0x72, 0xe6, 0x29, 0x2a, 0x22, 0x60,
	0x1e, 0x05, 0x25, 0xe3, 0x30, 0x75, 0x85, 0xe4, 0x8a, 0xe3, 0xa7, 0x5b, 0xda, 0x2d, 0x8c, 0xee,
	0xd7, 0x07, 0xdd, 0x1a, 0xf1, 0xc4, 0x67, 0x91, 0xa7, 0x6f, 0x0b, 0xb2, 0xef, 0x5e, 0xc8, 0x93,
	0x04, 0x42, 0xc5, 0xa5, 0x08, 0xca, 0xef, 0xfc, 0xb1, 0xee, 0x7e, 0xc4, 0x79, 0x94, 0x40, 0x09,
	0x2f, 0x33, 0xe9, 0xab, 0x98, 0xb3, 0xc2, 0x3f, 0xf8, 0xdf, 0x57, 0x31, 0x85, 0x54, 0xf9, 0x54,
	0xe4, 0x40, 0xef, 0x4f, 0x05, 0x99, 0x17, 0x3a, 0xe6, 0x8c, 0xc7, 0x4c, 0xe1, 0xb7, 0xa8, 0x76,
	0x13, 0xb3, 0xa5, 0x65, 0xd8, 0x86, 0xd3, 0x3e, 0x7a, 0xe1, 0xde, 0x19, 0xc6, 0xcd, 0xe9, 0x49,
	0xcc, 0x96, 0x44, 0xa3, 0xf8, 0x00, 0x99, 0xb9, 0xb7, 0x60, 0x3e, 0x05, 0xab, 0x62, 0x1b, 0x4e,
	0x8b, 0xa0, 0x5c, 0x9a, 0xfa, 0x14, 0xf0, 0x1b, 0x54, 0x4f, 0x95, 0x2f, 0x95, 0x55, 0xb5, 0x0d,
	0xc7, 0x3c, 0xea, 0xba, 0x79, 0x28, 0x77, 0x13, 0xca, 0x9d, 0x6f, 0x42, 0x91, 0x1c, 0xc4, 0xc7,
	0x68, 0x77, 0x33, 0x88, 0x55, 0xd3, 0x87, 0xf6, 0xee, 0x1c, 0x1a, 0x16, 0x00, 0xd9, 0xa2, 0xf8,
	0x18, 0x35, 0x12, 0x3f, 0x80, 0x24, 0xb5, 0xea, 0x76, 0xd5, 0x31, 0xff, 0x89, 0x5f, 0x6e, 0x6e,
	0x02, 0xab, 0x2b, 0x3f, 0xc9, 0x80, 0x14, 0x30, 0x7e, 0x89, 0x1e, 0x65, 0x31, 0x53, 0x27, 0xef,
	0x17, 0x3f, 0xd7, 0xba, 0xd5, 0xb0, 0x0d, 0xa7, 0xf6, 0x69, 0x87, 0x98, 0xb9, 0xaa, 0xe1, 0x35,
	0xb4, 0xe4, 0x59, 0x90, 0x40, 0x01, 0x35, 0x6d, 0xc3, 0x31, 0xd6, 0x50, 0xae, 0x6a, 0x68, 0xd0,
	0x44, 0x75, 0xed, 0xf6, 0x7e, 0x1b, 0xe8, 0xf1, 0x98, 0x45, 0x90, 0x2a, 0x02, 0x3f, 0x32, 0x48,
	0x15, 0x7e, 0x85, 0x9e, 0xc4, 0x4b, 0xa0, 0x82, 0x2b, 0x60, 0xe1, 0x6a, 0x71, 0x03, 0x2b, 0xbd,
	0xe3, 0x16, 0x69, 0xdf, 0x92, 0x27, 0xb0, 0xc2, 0x1f, 0xd0, 0xae, 0x04, 0xc1, 0xa5, 0x02, 0xa9,
	0x77, 0x79, 0xdf, 0x18, 0xa4, 0x80, 0xc8, 0x16, 0xc7, 0x27, 0xa8, 0x21, 0xd6, 0x2d, 0xa6, 0x56,
	0x55, 0xcf, 0xbf, 0x7f, 0x6f, 0x7d, 0xba, 0x6c, 0x52, 0xd0, 0xbd, 0x0e, 0x6a, 0x6f, 0xc2, 0xa6,
	0x82, 0xb3, 0x14, 0x5e, 0x7f, 0x44, 0xa8, 0xec, 0x19, 0x3f, 0x47, 0xcf, 0xc6, 0xd3, 0xab, 0xfe,
	0xf9, 0x78, 0xb8, 0xb8, 0x18, 0xcd, 0xc9, 0xf8, 0x74, 0x31, 0x19, 0x4f, 0x87, 0x9d, 0x1d, 0x6c,
	0xa2, 0xe6, 0xe9, 0xe7, 0xcb, 0xe9, 0x7c, 0x44, 0x3a, 0x06, 0x6e, 0xa1, 0xfa, 0x59, 0xff, 0xf2,
	0x6c, 0xd4, 0xa9, 0x0c, 0x3c, 0xb4, 0x17, 0x72, 0x7a, 0xeb, 0xf5, 0xfc, 0x0f, 0x77, 0x23, 0x29,
	0xc2, 0x99, 0xf1, 0xad, 0x55, 0x84, 0x11, 0xc1, 0xaf, 0x4a, 0xed, 0xfc, 0xcb, 0x6c, 0x10, 0x34,
	0x74, 0xad, 0xef, 0xfe, 0x06, 0x00, 0x00, 0xff, 0xff, 0xd5, 0x28, 0xa6, 0xbb, 0x80, 0x03, 0x00,
	0x00,
}
